# Copyright 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License version 3, as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/

import uuid


class CreditCard(object):

    def __init__(self, card_type, name_on_card, card_number, ccv_number,
                 expiration_month, expiration_year):
        self.card_type = card_type
        self.name_on_card = name_on_card
        self.card_number = card_number
        self.ccv_number = ccv_number
        self.expiration_month = expiration_month
        self.expiration_year = expiration_year

    def __repr__(self):
        return '%s(%r)' % (self.__class__, self.__dict__)

    @classmethod
    def make_test_visa_card(cls, unique_id=None):
        if unique_id is None:
            unique_id = str(uuid.uuid1())
        card_type = 'Visa'
        name_on_card = 'Test name {0}'.format(unique_id)
        card_number = '4111111111111111'
        ccv_number = '123'
        expiration_month = '12'
        expiration_year = '2026'
        return cls(card_type, name_on_card, card_number, ccv_number,
                   expiration_month, expiration_year)


class Address(object):

    def __init__(self, street_line1=None, street_line2=None, city=None,
                 state=None, postal_code=None, country=None):
        self.street_line1 = street_line1
        self.street_line2 = street_line2
        self.city = city
        self.state = state
        self.postal_code = postal_code
        self.country = country

    def __repr__(self):
        return '%s(%r)' % (self.__class__, self.__dict__)

    @classmethod
    def make_unique(cls, unique_id=None):
        if unique_id is None:
            unique_id = str(uuid.uuid1())
        street_line1 = "Test street line 1 {0}".format(unique_id)
        street_line2 = "Test street line 2 {0}".format(unique_id)
        city = "Test city {0}".format(unique_id)
        state = "Test state {0}".format(unique_id)
        postal_code = "12345"
        country = "United States"
        return cls(
            street_line1, street_line2, city, state, postal_code, country)
